demo_song equ 6
	device zxspectrum128
        ORG #6000
begin
 include "TSPor.inc"
 jp start_demo
;------------------------ common rouitines ------------------------
notecnt:db 0
call_before:dw 0
call_after: dw 0
int_count: dw 0

intvec:
 push ix,iy
 push hl,de,bc,af
 exx:exa
 push hl,de,bc,af

 ld hl,(int_count):inc hl:ld (int_count),hl

 ld hl,(call_before):ld a,h:or l:call nz,callbyhl

 ld bc,Page3
 in a,(c)
 push bc,af
 ld a,demo_song
 out (c),a
 call PLAY
 ld a,(CurPos)
 ld (notecnt),a
 pop af,bc
 out (c),a

 ld hl,(call_after):ld a,h:or l:call nz,callbyhl

 pop af,bc,de,hl
 exx:exa
 pop af,bc,de,hl
 pop iy,ix
 ei:ret
callbyhl: jp (hl)
zx7:include "zx7.a80"
;----------------DMA clear page------------------------
clear_page_dma:
DMA_RAM_CRAM    equ $84
 ;push af
 ld bc,Page3
 out (c),a
cp_v: ld hl,0
 ld (#c000),hl
 ld bc,#1AAF
 ld hl,$C000
 out (c),l;DMASAddrL    EQU	#1AAF
 inc b
 out (c),h;l;DMASAddrH    EQU	#1BAF
 inc b
 out (c),a;h;DMASAddrX    EQU	#1CAF
 inc b

 ld l,2
 out (c),l;DMADAddrL    EQU	#1DAF
 inc b
 out (c),h;l;DMADAddrH    EQU	#1EAF
 inc b
 out (c),a;h;DMADAddrX    EQU	#1FAF
 ld l,255
 ld b,#26
 out (c),l;DMALen    EQU	#26AF
 inc b
 inc b
 
 exa
 ld a,31;15+2;(15+1)*2=32, 32*512=16384
 out (c),a;;l;DMANum    EQU	#28AF
 dec b
 ld a,%00000100; FILL->RAM
 out (c),a;DMACtrl   EQU	#27AF
waitdma1:
 inf
 jp m,waitdma1
 exa;pop af
 ret

;14:27] <vbi>   128  
;[14:27] <vbi>  128  
;[14:27] <vbi> .. -  = 128/2-1
set_ports  ld c,#AF
m1   ld b,(hl)
     inc hl
     inc b
     jr z,dma_stats
     outi
     jr m1
dma_stats  ld b,high DMAStatus
     in a,(c)
     AND #80
     jr nz,$-4
     ret
;------------------------------------------------------
start_demo:
  ld sp,$5FE0
  ld bc,Page3,a,6:out (c),a
  
   ld hl,song:call INIT

;-------- zero cram etc --------
 ld hl,$4000,de,$4001,(hl),l,bc,512:ldir
 ld bc, FMAddr
 ld a, %00010000
 out (c), a
 ld de,0
 ld hl,$4000
 ld bc,512
 ldir
 ld bc, 0x15AF
 xor a
 out (c), a

 ld a,$10
 ld bc,FMAddr
 out (c),a
 ld hl,$4000
 ld de,512
 ld bc,512
 ldir
 xor a
 ld bc,FMAddr
 out (c),a
 ld bc,PalSel
 out (c),a

;setup im2
 di
 ld a,$5F,i,a
 ld hl,intvec,($5FFF),hl
 im 2
 
   ld a,6,bc,SysConfig:out (c),a

;  	call part7
;	jr $

   call part1;checker animation, title, rohmb tile

   call part2;plasma fadin and out

   call part3;greetz+twister
   
   call part4;rasters

   call part5;bgr

   call part6;sinedots

   call part7;bars+final

   jr $
;----------------------------------Demo parts------------------------
part1:
; VIDEO
VID_256X192     equ $00
VID_320X200     equ $40
VID_320X240     equ $80
VID_360X288     equ $C0
VID_ZX          equ $00
VID_16C         equ $01
VID_256C        equ $02
VID_TEXT        equ $03
VID_NOGFX       equ $20
; TSU
TSU_T0ZEN		equ $04
TSU_T1ZEN		equ $08
TSU_T0EN		equ $20
TSU_T1EN		equ $40
TSU_SEN			equ $80

 ld a,64
 ld bc,SGPage
 out (c),a

	xor a
	ld	bc,T0XOffsL
	out	(c),a
	inc b;ld	bc,T0XOffsH;#41af
	out	(c),a
	ld hl,-360
	inc b;ld	bc,T0YOffsL;#42af
	out	(c),l
	inc b;ld	bc,T0YOffsH;#43af
	out	(c),h

	inc b;ld	bc,T1XOffsL;#44af
	out	(c),a
	inc b;ld	bc,T1XOffsH;#45af
	out	(c),a
	inc b;ld	bc,T1YOffsL;equ	#46af
	out	(c),a
	inc b;ld	bc,T1YOffsH;equ	#47af
	out	(c),a

 LD  BC,VConfig
 LD  A,%01000001; VID_320X200|VID_16C, ,%01010001 with no_tsu
 OUT (C),A
 LD  BC,VPage
 LD  A,$28
 OUT (C),A

 ld bc, FMAddr
 ld a, %00010000
 out (c), a
;load CRAM
 ld hl,spr_pal
 ld de,32
 ld bc,32
 ldir
;for tiles
 ld hl,0,($0080),hl;Tile with color 0
 ld hl,$7FFF,($0082),hl;Tile with color 1
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a
 
 ld bc,PalSel
 ld a,%00010000
 out (c),a

 ld bc,Border
 ld a,64
 out (c),a
;----------------------------------------
 ld hl,fnt_pack,de,$4000:call dzx7_standard
 ld a,$10
 call clear_page_dma
 ld bc,T0GPage;    0   $10
 out (c),a
; ld bc,T1GPage
; out (c),a
 call convert_font

 ld hl,fnt_pack,de,$5000:call dzx7_standard

; MAP tile
 ld a,$11
 call clear_page_dma
 ld bc,TMPage
 out (c),a

 ld bc,TSConfig
 ld a,TSU_T0EN | TSU_T0ZEN|TSU_SEN
 out (c),a


; ld de,140
; ld bc,0;8+8
; call recalc_sprite;de=192,bc=16

;-------
 ld ix,text1,de,$C004:call text4x4

 ld hl,$5000
 ld b,8
che_lp1:
 ld (hl),31:inc l
 ld (hl),0:inc l
 djnz che_lp1
 ld b,16
che_lp2:
 ld (hl),0:inc l
 djnz che_lp2

 ld hl, checker_roll,(call_before),hl

 ld c,6:call wait_n
;-------------------displacement for tiles
 ld hl,196
part1_lp02:
 ei:halt
 push hl
	xor a
	ld	bc,T0XOffsL
	out	(c),a
	ld	bc,T0XOffsH
	out	(c),a
fallv:ld hl,fall
    ld e,(hl):inc hl
    ld d,(hl):inc hl
    ld a,e:cpl:ld e,a
    ld a,d:cpl:ld d,a
    inc de
    ld (fallv+1),hl
	ld	bc,T0YOffsL
	out	(c),e
	ld	bc,T0YOffsH
	out	(c),d

	pop hl
	dec hl:ld a,h:or l:jp nz,part1_lp02

 ld ix,text2,de,$C914+8:call text4x4
 ld c,8:call wait_n
 
; ld ix,text3,de,$D504+4:call text4x4
 ld de,140
 ld bc,0;8+8
 call recalc_sprite;de=192,bc=16

 ld c,9:call wait_n
 
; 
 ld a,31
fadewh_lp:
 ei:halt
 call make_white
 dec a:jp nz,fadewh_lp
;-----------------------------------------
 ei:halt
 ld a,$11
 call clear_page_dma
 ld bc,TMPage
 out (c),a

 ld a,16*2
 ld de,$4000
cop1:
 ld hl,sq;+8
 ld bc,128:ldir
 dec a:jr nz,cop1

 ld c,$0A:call wait_n
 
 ei:halt
 ld hl, 0,(call_before),hl
 LD  BC,VConfig
 LD  A,VID_320X200|VID_NOGFX
 OUT (C),A

 ld bc,TSConfig
 ld a,TSU_T0EN | TSU_T0ZEN;|TSU_SEN
 out (c),a

 ei:halt
 ld a,$10
 call clear_page_dma
 ld bc,Page3
 out (c),a
 ld bc,T0GPage
 out (c),a
 call convert_font


 ei:halt
 ld a,$11
 ld bc,Page3
 out (c),a

;;fill by tiles
 ld de,12*256
 ld hl,$C000
ro_lp0:
 ld b,22
 push hl,de
ro_lp1:
 ld (hl),e:inc l
 inc e
 ld (hl),0:inc l
 djnz ro_lp1

 ld b,22
ro_lp2:
 ld (hl),e:inc l
 dec e
 ld (hl),0:inc l
 djnz ro_lp2

 pop de,hl
 inc h
 inc e
 dec d:jr nz,ro_lp0
 
 ld d,12+1
ro_lp00:
 ld b,22
 push hl,de
ro_lp01:
 ld (hl),e:inc l
 inc e
 ld (hl),0:inc l
 djnz ro_lp01

 ld b,22
ro_lp02:
 ld (hl),e:inc l;$34;$2C
 dec e
 ld (hl),0:inc l
 djnz ro_lp02

 pop de,hl
 inc h
 dec e
 dec d:jr nz,ro_lp00

;-prepare out
out_r equ $4800
;---
 ld hl,out_r
 ld b,22*2
prep1:
 ld (hl),$34:inc hl
 ld (hl),$2C:inc hl
 ld (hl),$2C:inc hl
 djnz prep1
 ld (hl),$C9:inc hl
;---
 ld a,31:call make_white
 
romb: ei:halt
romb_p: call ro_r1

 ld hl,$C000,d,24+1
ro_lp_3:
 ;push hl
 call out_r
 ld l,0
; dup 22*2
; inc (hl),l,l
;edup
 ;pop hl
 inc h
 dec d
 jp nz,ro_lp_3
 jp romb

ro_r2:
rva1:ld hl,0
 ld	bc,T0YOffsL
 out (c),l
 inc b;ld	bc,T0YOffsH
 out (c),h
 ld bc,10;/5
 or a:sbc hl,bc
 ld (rva1+1),hl
rva2:ld a,32
 dec a:ld (rva2+1),a
 ret nz
 xor a:call make_white
 pop af
 ret
ro_r1:
 ld a,(notecnt):cp $0D:ret nz
 ld hl,ro_r2:ld (romb_p+1),hl
 ret
;------------------------------------------------------
make_white:;A=num
 ld l,a,h,0
 push hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 push hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 pop de
 add hl,de
 pop de
 add hl,de
 
 push af
 ld bc, FMAddr
 ld a, %00010000
 out (c), a
;load CRAM
 ld ($0082),hl;Tile with color 1
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a
 pop af
 ret
;wait_note;C=num
wait_n:ei:halt
 ld a,(notecnt):cp c:jp nz,wait_n
 ret
checker_roll:
 ld hl,pals
 call set_ports
 
 ld hl,($5000):push hl
 ld de,$5000,hl,$5000+2,bc,32:ldir
 pop hl:ld ($5000+30),hl
 ret
 
pals
 db #1a,0;low pal
 db #1b,$50;high pal
 db #1c,5;DMASAddrX---5

 db #1d,0;DMADAddrL
 db #1e,0;DMADAddrH
 db #1f,0;DMADAddrX

 db #26,#10;DMALen ; [14:15] <vbi>     ,     
 db #28,0;DMANum 32/DMALen-1
 db #27,DMA_RAM_CRAM     ; #84 -   RAM  CRAM
 db #ff

text4x4:
;ix=text
;de=adr
t4x4_lp: ld a,(ix):inc ix
 or a:ret z
  cp "_":jr nc,findadr4x4
 sub 32
findadr4x4:
 ld l,a,h,8+1+1;9*8=$48,+8=$50 font place
 add hl,hl
 add hl,hl
 add hl,hl
;hl=font data adress
 push de
 ld a,4
char_lp4x4_2:
 push af,de
 ld a,4
 ld b,(hl):inc hl
 ld c,(hl):inc hl
char_lp4x4_1:
 exa
 xor a
 rl b:rla:rl c:rla
 rl b:rla:rl c:rla
 ld (de),a:inc e,e
 exa
 dec a:jr nz,char_lp4x4_1
 pop de,af
 inc d
 dec a:jr nz,char_lp4x4_2
 pop de
 inc e,e,e,e,e,e,e,e
 jp t4x4_lp
;----------------------------------------
out_text:
ot_lp:
 ld a,(hl):inc hl
 or a:ret z;stu:or a:jr z,stu
 cp "_":jr nc,put_char
 sub 32
put_char:
 ld (de),a:inc e
 xor a
 ld (de),a:inc e
 jr ot_lp
text1: db "Goblinish",0; in carousel",0
text2: db "in",0
;text3: db "Carousel",0
;----------------------------------------
convert_font:
 ld hl,bits,de,#5800,bc,4:ldir

 ld hl,$4000
 ld de,$C000
ch2:
 ld ixl,8
 push de
ch1:
 push de
 dup 4
 xor a
 rl (hl):adc a,0:add a,a
 rl (hl):adc a,0
 ld c,a,b,$58
 ld a,(bc),(de),a:inc e
edup
 pop de
 inc d
 inc hl
 dec ixl:jr nz,ch1
 pop de
 ld a,e:add a,4:ld e,a:jr nz,none1
 ld a,d:add a,8:ld d,a
none1:
 ld a,d:cp $E0
 jp nz,ch2
 ret
clr0 equ 0;for font - back color
clr1 equ 1
bits: db clr0*17,clr0*16+clr1,clr1*16+clr0,clr1*17
sq:incbin "sq.fnt"
fall:include "fall.inc"
fnt_pack:incbin "AVANTFNT.zx7"
;-------------------------------------------------------Part 2-plasma---------------------------------
plasma_tilebmp0_page equ $10
plasma_tilemap_page1 equ $11
plasma_tilemap_page2 equ $12
part2:

 ei:halt
 ld a,demo_song,bc,Page3:out (c),a
 ld hl,plasm_fnt,de,$4000:call dzx7_standard

plasm_sin equ $4800
 ld de,plasm_sin,hl,pla_sin,bc,256:ldir

 ld hl,$5000,de,$5001,bc,512,(hl),0:ldir
 ld hl,pals
 call set_ports

 ld bc,PalSel
 xor a
 out (c),a

 ei:halt
 ld a,plasma_tilebmp0_page;$10
 call clear_page_dma
 ld bc,T0GPage;//    0   $10
 out (c),a

; MAP tile
 ei:halt
 ld a,plasma_tilemap_page1;$11
 call clear_page_dma
 ei:halt
 ld a,plasma_tilemap_page2;$12
 call clear_page_dma
 ld bc,TMPage
 out (c),a


 LD	BC,VConfig
 LD	A,VID_NOGFX | VID_360X288
 OUT	(C),A

 ld bc,TSConfig
 ld a,TSU_T0EN | TSU_T0ZEN;%01101100;TSU_T0EN | TSU_T1EN | TSU_T0ZEN | TSU_T1ZEN;%01101100
 out (c),a

	xor a;ld	hl,0
	ld	bc,T0XOffsL
	out	(c),a
	inc b;ld	bc,T0XOffsH
	out	(c),a
	inc b;ld	bc,T0YOffsL
	out	(c),a
	inc b;ld	bc,T0YOffsH
	out	(c),a
	inc b;ld	bc,T1XOffsL
	out	(c),a
	inc b;ld	bc,T1XOffsH
	out	(c),a
	inc b;ld	bc,T1YOffsL
	out	(c),a
	inc b;ld	bc,T1YOffsH
	out	(c),a

;-------generate tile
 ei:halt
 ld a,plasma_tilebmp0_page;$10
 ld bc,Page3
 out (c),a

 ld hl,$4000
 ld de,$C000
plasm_lp3:
 push de
plasm_lp2:
 ld c,(hl):inc hl
 push de
 ld b,4
plasm_lp1:
 xor a
 rl c:rla
 rl c:rla
 ld ixl,a
 add a,a
 add a,a
 add a,a
 add a,a
 or ixl
 ld (de),a:inc de
 djnz plasm_lp1
 pop de
 inc d
 ld a,d:and 7:jp nz,plasm_lp2
 pop de
 inc e,e,e,e:jp nz,plasm_lp3
 ld a,d:add a,8:ld d,a
 cp $D0
 jp nz,plasm_lp3

;plasma

; generate for gade
plasma_col equ $4900
 ld hl,plasma_col
genf_lp:
 push hl
 ld h,0
 add hl,hl;2
 add hl,hl;4
 add hl,hl;8
 add hl,hl;16
 add hl,hl;32
 ld de,hl

 add hl,hl;64
 add hl,hl;128
 add hl,hl;256
 add hl,hl;512
 add hl,hl;1024
 ld bc,hl

 pop hl
 ld a,h
 ld (hl),e:inc h
 ld (hl),d:inc h
 ld (hl),c:inc h
 ld (hl),b:inc h
 ld h,a
 inc l
 bit 5,l:jr z,genf_lp
;-----------intro
; ld a,$12
; ld bc,Page3
; out (c),a

dointro: ei:halt
 ld h,plasm_sin/256
plasma_pg:ld a,plasma_tilemap_page2;;;;;;;;;;;;;;;;stop at $12
 ld bc,TMPage
 out (c),a
 xor 3
 ld (plasma_pg+1),a
 ld bc,Page3
 out (c),a

plasma_po: call plasma_fadein
 exx
 ld hl,#c000
 ld c,127
 exx
 ld h,plasm_sin/256
 ld ixl,36
var2:ld bc,0
ylp:
var1:ld de,0
xlp:
 ld l,e,a,(hl)
 ld l,d:add a,(hl)
 ld l,c:add a,(hl)
 ld l,b:add a,(hl)
 inc d
 inc e
 inc e
; inc e
 
 exx
 and c
 ld (hl),a:inc l
 inc l
 ld a,l
 exx
 
 cp 45*2:jr nz,xlp
 inc b
 inc c,c
 exx
 ld l,0
 inc h
 exx
 dec ixl
 jp nz,ylp
 
 ld hl,var2+1
 inc (hl)
 inc hl
 inc (hl)
 inc (hl)

 ld hl,var1+1
 dec (hl)
 inc hl
 inc(hl):inc(hl)

 jp dointro
;----------------------------------------------------
plasma_delay:
 ld a,(notecnt):cp $12:ret nz
; ret
; xor a:in a,($FE):cpl:and 31:ret z

 ld hl,plasma_fadeout,(plasma_po+1),hl
 
 ret
plasma_fadeout:
pfov1:ld a,0:xor 1:ld (pfov1+1),a:ret nz
 ld b,12
 ld ix,plasma_rgb
pfo_lp:
 ld a,(ix+0):or a:jr z,fo_skip
 dec (ix+0)
fo_skip:
 inc ix,ix:djnz pfo_lp
 call plasma_writepal
pfov3:ld a,34:dec a:ld (pfov3+1),a:ret nz
 pop af
 ret


plasma_fadein:
pfv1:ld a,0:xor 1:ld (pfv1+1),a:ret nz
fadein_pal equ $5000
 ld b,12
 ld ix,plasma_rgb
pfi_lp:
 ld a,(ix+0):cp (ix+1):jr z,fi_skip
 inc (ix+0)
fi_skip:
 inc ix,ix:djnz pfi_lp
 call plasma_writepal
pfiov1:ld a,33:dec a
 ld (pfiov1+1),a:ret nz
 ld hl,plasma_delay,(plasma_po+1),hl
 ret
plasma_writepal:
 ld b,4
 ld ix,plasma_rgb
 exx:ld hl,fadein_pal:exx
fi_store:
 ld h,plasma_col/256
 ld l,(ix+0)
;R
 ld e,(hl):inc h
 ld d,(hl):inc h
 push de
 inc ix,ix
;G
 ld l,(ix+0)
 ld e,(hl):inc h
 ld d,(hl):inc h
;B
 inc ix,ix
 ld l,(ix+0)
 ld h,0
 ;add hl,de
 ld a,l:or e:ld l,a
 ld a,h:or d:ld h,a
 pop de
 ;add hl,de
 ld a,l:or e:ld l,a
 ld a,h:or d:ld h,a

 inc ix,ix

 push hl
 exx
 pop de
 ld (hl),e:inc l
 ld (hl),d:inc l
 exx
 
 dec b:jp nz,fi_store
 
  ld bc, FMAddr
 ld a, %00010000;$18;;%00010000
 out (c), a
;load CRAM
 ld de,0;$8000
 ld hl,fadein_pal
 ld bc,8;plasm_pal_e-plasm_pal_b
 ldir
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a
 ret

plasma_rgb:
 db 0,0;R-0,start, value
 db 0,0;G-0
 db 0,0;B-0
 
 db 0,0;1
 db 0,0
 db 0,31
 
 db 0,31;2
 db 0,0
 db 0,31
 
 db 0,31;3
 db 0,31
 db 0,31
;-----------------------------------------------------------------------------------------------------
part3:

twist_tilebmp_page equ $10
twist_tilemap_page1 equ $11
twist_tilemap_page2 equ $12

 ld a,twist_tilebmp_page;$10
 call clear_page_dma
 ld bc,T0GPage; = 16 //    0   $10
 out (c),a
 ld bc,T1GPage
 out (c),a
;--------generate tile-------------
 ld de,$C000,b,0
genlp:
 ld a,b
 and $F0
 ld c,a
 rra:rra:rra:rra
 or c
 ld h,a;H.L

 ld a,b
 and $0F
 ld c,a
 add a,a
 add a,a
 add a,a
 add a,a
 or c
 ld l,a

 push de
 ld ixl,4
put_tile:
 push de
 ld a,h
 ld (de),a:inc e;12
 ld (de),a:inc e;34
 ld a,l
 ld (de),a:inc e;56
 ld (de),a:inc e;78
 pop de
 inc d
 dec ixl:jp nz,put_tile
 pop de
 inc b:jr z,stop_gen
 ld a,e:add a,4:ld e,a:jp nz,genlp
 ld a,d:add a,8:ld d,a:jp genlp
stop_gen:
;gen 256 tile
;19:45] <TSL> 000
;[19:45] <TSL>   (64 )  2
;[19:45] <TSL>  256/4 = 4  = 8
;[19:46] <TSL> 000 + 8 = 000

 ld ix,$E100,b,7
 ld a,$22,($E000),a,($E001),a,($E002),a,($E003),a
tile256:
 ld (ix+0),$21
 ld (ix+1),$11
 ld (ix+2),$11
 ld (ix+3),$11
 inc ixh:djnz tile256
;----------------------------------
; MAP tile
 ei:halt
 ld a,twist_tilemap_page1;$11
 call clear_page_dma
 ei:halt
 ld a,twist_tilemap_page1;$12
 call clear_page_dma
;-depack
 ei:halt
 ld a,demo_song,bc,Page3:out (c),a

 ld hl,twist0p,de,$4800:call dzx7_standard
 ld hl,twist1p,de,$4B00:call dzx7_standard
 ld hl,gfnt_pack,de,$5000:call dzx7_standard

;-------
sintwpos equ $4000
sinhei equ sintwpos+256
 ld hl,sintw
 ld de,sintwpos
 ld bc,256
 ldir

 call twist_set_pal
;twist_set_pal:
; ;open FMAddr access from 0x8000
; ld bc, FMAddr
; ld a, %00010000;0x18
; out (c), a
;;load CRAM
; ld de,0
; ld hl,plasm_pal_b
; ld bc,plasm_pal_e-plasm_pal_b
; ldir
;;close FMAddr
; ld bc, FMAddr
; xor a
; out (c), a
;;PalSel = %00 //   0   0
;;PalSel          EQU	#07AF
; ld bc,PalSel
; xor a
; out (c),a


 ld bc,TSConfig
 ld a,%01101100;TSU_T0EN | TSU_T1EN | TSU_T0ZEN | TSU_T1ZEN;%01101100
 out (c),a

 ld hl,sinhei
 ld de,0
 ld b,32
tw_lut:
 ld (hl),e:inc h
 ld (hl),d:dec h
 inc l
 ld a,e:add a,17:ld e,a
 ld a,d:adc a,0:ld d,a
 djnz tw_lut

twist_lp2:
 ld hl,$c000,(tw_y+1),hl
 ld a,$0,(twflag+1),a
 ei:halt
tw_page:ld a,twist_tilemap_page1
 ld bc,TMPage
 out (c),a
 xor 3
 ld (tw_page+1),a
 ld bc,Page3
 out (c),a
 call clear_page_dma

twv2: ld hl,0
 inc h,h,l
 ld (twv2+1),hl
 ld (twv1+1),hl

twv4: ld hl,0
 inc h,h,l
 ld (twv4+1),hl
 ld (twv3+1),hl
;--------------------------
 ld ixl,32*3
twist_lp:
twv1:ld bc,0
 ld h,sintwpos/256
 ld l,c
 ld a,(hl)
 ld l,b
 add a,(hl)
 and 31
 inc b
 dec c
 ld (twv1+1),bc
 inc h
; ld a,ixl
 ld l,a

 ld e,(hl):inc h:ld d,(hl);displacement

;and Y
twv3:ld bc,0
 ld h,sintwpos/256
 ld l,c
 ld a,(hl)
 ld l,b
 add a,(hl)

; jr $

 inc c
 dec b,b
 ld (twv3+1),bc
 ld c,a,b,0

 ld hl,$4800;twist0
 bit 0,c:jr z,tw_nonew_pos
 ld h,$4B;ld hl,twist1
tw_nonew_pos:
 add hl,de
 ex de,hl

tw_y: ld hl,$C000
 srl c
 res 0,c
 add hl,bc
twflag:ld c,0

 dup 17
 ld a,(de):inc de
 ld (hl),a:inc l
 ld (hl),c:inc l
edup
; jr $
; ld l,0
 ld a,(twflag+1):xor $80:ld (twflag+1),a
 ld l,a
; or a:jp m,tw_next_pos
 jr nz,tw_next_pos
 inc h
; ld l,128
tw_next_pos:
 ld (tw_y+1),hl
 dec ixl:jp nz,twist_lp
 
twist_po: call greetz2

 jp twist_lp2
;-----------inner soubroutines-----------------------
fade_tw:

 ld ix,plasm_pal_b
 ld b,16
 ld de,32
ftw_lp:
 ld l,(ix+0),h,(ix+1)
 ld a,l:or h:jr z,no_tw_fade
 or a:sbc hl,de
no_tw_fade:
 ld (ix+0),l
 ld (ix+1),h
 inc ix,ix
 dec b:jp nz,ftw_lp

twist_set_pal:
 ;open FMAddr access from 0x8000
 ld bc, FMAddr
 ld a, %00010000;0x18
 out (c), a
;load CRAM
 ld de,0
 ld hl,plasm_pal_b
 ld bc,plasm_pal_e-plasm_pal_b
 ldir
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a
;PalSel = %00 //   0   0
;PalSel          EQU	#07AF
 ld bc,PalSel
 xor a
 out (c),a

ftwv1: ld a,32:dec a:ld (ftwv1+1),a:ret nz
 pop af
 ret

greetz2:
gp: ld ix,gtext
 call greetz
gcnt: ld a,0:inc a:ld (gcnt+1),a
 and 63:ret nz;jp nz,twist_lp2
 ld (gp+2),ix
 ld a,(ix+0):or (ix+1):ret nz
 ld hl,fade_tw,(twist_po+1),hl
 ret
greetz:
 ld e,(ix+0)
 ld d,(ix+1)
 ld a,e:or d:ret z
 inc ix,ix
g_lp:
 ld a,(ix+0):inc ix
 or a:ret z
gget_char:
 ld l,a,h,$50
 ld b,128
 ld c,8
 push de
gret_lp2:
 push de
gret_lp1:
 ld a,(hl):and b:jr z,next_ch
 xor a
 ld (de),a:inc de
 ld a,%00010001;tpal[5:4]+tile256
 ld (de),a:dec de
next_ch:
 inc de,de
 or a:rrc b
 bit 3,b:jr z,gret_lp1
 ld b,128
 inc h
 pop de
 inc d
 dec c:jp nz,gret_lp2
 pop de
 inc de,de,de,de,de,de,de,de

 jp g_lp
;----------------------------------------------------
gtext:
 dw $C080
 db " ",0;delay

 dw $C180
 db "Greetz to:",0
 dw $D080
 db "CC visitors",0
 dw $C380
 db "TS-Labs",0
 dw $C784
 db "Moroz1999",0
 dw $D788
 db "wbc",0

 dw $D980
 db "Optimus",0
 dw $D080
 db "sensenstahl",0
 
 dw $C880
 db "DDp",0

 dw $C090+30
 db "VBI",0

 dw $C990
 db "Buyan",0


 dw 0;;;end of file

plasm_pal_b:

 dw 32*0;0
 dw 32*1;1
 dw 32*3;2
 dw 32*5;3
 dw 32*6;4
 dw 32*10;5
 dw 32*14;6
 dw 32*19;7

 dw 32*21;8
 dw 32*23;9
 dw 32*24;10
 dw 32*25;11
 dw 32*27;12
 dw 32*29;13
 dw 32*30;14
 dw 32*31;15

 dw 0
 dw $7FFF
 dw 0
plasm_pal_e:
;-----------------------------------------------------------------------------------------------------
part4:

 ld bc,TSConfig
 xor a
 out (c),a

; MAP tile
 ld a,$12
 ei:halt
 call clear_page_dma
 ld bc,TMPage
 out (c),a

 ei:halt
 ld a,$10
 call clear_page_dma
 ld bc,T0GPage; = 16 //    0   $10
 out (c),a
; ld a,$11
; ei:halt
; call clear_page_dma
 ld bc,T1GPage
 out (c),a


 ei:halt
 ld a,$12;tile map
 ld bc,Page3
 out (c),a

;-----------------------------setpal
 ;open FMAddr access from 0x8000
 ld bc, FMAddr
 ld a, %00010000;0x18
 out (c), a
;load CRAM
 ld de,0
 ld hl,rast_pal_b
 ld bc,rast_pal_e-rast_pal_b
 ldir
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a

 ld bc,PalSel
 xor a
 out (c),a

 LD	BC,VConfig
 LD	A,VID_NOGFX | VID_360X288
 OUT	(C),A

 ld bc,TSConfig
 ld a,TSU_T0EN | TSU_T1EN | TSU_T0ZEN | TSU_T1ZEN
 out (c),a

;----drawbars on tilemap
 ld hl,$C000
 ld d,1
 call rast_drwtile

 ld hl,$C080
 ld d,40
 call rast_drwtile


  ei:halt
 ld a,demo_song,bc,Page3:out (c),a
 ld hl,$4000,de,$4001,bc,4097,(hl),l:ldir
;buffer 256b for tile
l_buf equ $5000
 ld hl,l_buf
fill_buf:
 ld (hl),$FF:inc l:jr nz,fill_buf
;sinus 255 bytes 72+72*sin
rastasp equ $4000
 ld hl,rastasin;position
 ld de,rastasp
 ld bc,256*2
 ldir
;colorbuffer 512 bytes
rastabuf equ $4200

;  $c004, 288*word
rasta_tile_adr equ $4400
 ld hl,rasta_tile_adr
 ld de,$C004
 ld b,36
r_lut1:
 push de
 ld c,8
r_lut2:
 ld (hl),e:inc hl
 ld (hl),d:inc hl
 inc d
 dec c:jr nz,r_lut2
 pop de
 ld a,e:add a,4:ld e,a
 dec b:jp nz,r_lut1
 ei:halt
 ld a,$10
 ld bc,Page3
 out (c),a

rastalp:
 ei:halt
rastapo:call rasta_wait_start

rasv:ld hl,rastasp
 inc l
 ld (rasv+1),hl
 
 ld c,16+8
ras16:
  push hl
  ld e,(hl):inc h
  ld d,(hl);:dec h
  
  ld hl,rastabuf
  add hl,de
  ld de,barcol

; jr $
 dup 16
 ld a,(de)
 or a
 jr z,$+3
 ld (hl),a
 inc hl,de
edup

 pop hl
 inc l,l,l
 dec c:jp nz,ras16
;-------------------- out raster --------------------
 ld ix,rasta_tile_adr
 ld hl,rastabuf
 ld bc,288
out_rast:
 ld a,(hl)
 ld (hl),0:inc hl
 ld e,(ix):inc ix
 ld d,(ix):inc ix
 
 ld (de),a:inc e
 ld (de),a:inc e
 ld (de),a:inc e
 ld (de),a:inc e

 dec bc:ld a,b:or c:jp nz,out_rast

 jp rastalp
;---------------Part routines-------------------------------------
rasta_wait_start:
 ld a,(notecnt)
 cp $1B
 ret nz
 ld hl,rasta_draw,(rastapo+1),hl
 ret
rasta_draw:
rdv1:ld b,1
 ld hl,l_buf
rd_lp:
 inc (hl):res 3,(hl)
 inc l:djnz rd_lp
; and fill
 ld de,l_buf
 ld hl,$C000+40*4
 ld a,(rdv1+1),b,a
rdd_lp:
 ld a,(de)
 push hl
 or h:ld h,a
 ld (hl),$99:inc l
 ld (hl),$99:inc l
 ld (hl),$99:inc l
 ld (hl),$99:inc l
 pop hl
 ld a,l:add a,4:ld l,a
 jr nz,rdd_next
 inc h,h,h,h,h,h,h,h
rdd_next:
 dec b:jp nz,rdd_lp
 ld a,(rdv1+1)
 cp 37:jr z,rdd_cunt; not count but cunt like AlCo
 inc a:ld (rdv1+1),a
 ret
rdd_cunt:ld a,8
 dec a:ld (rdd_cunt+1),a:ret nz
 ld hl,rast_dark,(rastapo+1),hl
 ret
;fadeout tile
rast_dark:
radv2:ld a,0:inc a:ld (radv2+1),a:and 15:ret z
radv1:ld a,7
 push af
 ld l,a,h,0
 push hl
 add hl,hl;*2
 add hl,hl;*4
 add hl,hl;*8
 add hl,hl;*16
 add hl,hl;*32
 push hl
 add hl,hl;*64
 add hl,hl;*128
 add hl,hl;*256
 add hl,hl;*512
 add hl,hl;*1024

 pop de:add hl,de
 pop de:add hl,de

 ld bc, FMAddr
 ld a, %00010000
 out (c), a
;load CRAM
 ld (9*2),hl
;close FMAddr
 xor a
 out (c), a
 pop af:dec a:ld (radv1+1),a
 ret p
 pop af
 ret

rast_drwtile:

 ld c,37
dr_lp1:
 ld b,32+13
 push hl
dr_lp2:
 ld (hl),d:inc l
 ld (hl),0:inc l
 djnz dr_lp2
 pop hl
 inc h
 inc d
; ld a,d
; cp 37
 dec c
 jp nz,dr_lp1
 ret

barcol:
 db $00,$11,$22,$33,$44,$55,$66,$77
 db $88,$77,$66,$55,$44,$33,$22,$11

rast_pal_b:;R&B
n=0
 dup 9
 dw 1024*n+32*0+n
n=n+3
 edup
 
 dw $7FFF
rast_pal_e:
;-----------------------------------------------------------------------------------------------------
part5:
 ld bc,TSConfig
 xor a
 out (c),a

 ld hl,-(320-20)
 ld bc,GYOffsL
 out(c),l
 inc b
 out(c),h

;clear pages
 ld hl,$7F7F,(cp_v+1),hl
 ld a,40-1
bgr_lp:
 ei:halt
 call clear_page_dma
 inc a
 cp 48:jr nz, bgr_lp
 ld hl,0,(cp_v+1),hl


 LD  BC,VPage      ;  ,     #20
 LD  A,#20         ;  
 OUT (C),A
 LD  BC,VConfig    ;  : %11-360x288, %10-256 
 LD  A,%01010010;;%01000010
 OUT (C),A

 ei:halt
 ld a,demo_song,bc,Page3:out (c),a

;makepal two
 ld de,$5000
 ld hl,palb
 ld bc,512:ldir

 ld hl,palb
 ld bc,512:ldir

 ei:halt
 ld hl,$5000:call bgr_set_pal
 
 ld a,127-1
 ld bc,#0FAF:out (c),a
 
 ld hl,-(320-20)
roll:ei:halt
 ld bc,GYOffsL
 out(c),l
 inc b
 out(c),h
 inc hl,hl
 inc hl,hl
 ;bit 7,h
 ld a,h:or l
 jr nz,roll
 ld bc,GYOffsL
 out(c),l
 inc b
 out(c),h
;------------------------copy palette to CRAM------------------

tst:
 ei:halt
pv:ld hl,0
 inc l;,l
 ld (pv+1),hl
 add hl,hl
 ld de,$5000;palb
 add hl,de

 push hl
 call bgr_set_pal

border:ld a,$7D;-1
 ld bc,#0FAF;(4015)  Border.  .
 out (c),a
; inc a
;; inc a
; ld (border+1),a
; ld bc,#0FAF;(4015)  Border.  .
; out (c),a
; jp tst
;find black border
 pop ix
 ld b,0
find_p:
 ld a,(ix+0):or (ix+1):jr z,find_black
 inc ix,ix
 inc b:jp nz,find_p
find_black:
 ld a,b
; inc a
 inc a
 ld (border+1),a
; jr $
bgr_poi:call bgr_wait
 jp tst
;-------------Part routines------------------------
bgr_wait:
 ld a,(notecnt):cp $1E+1:ret nz
; xor a:in a,($FE):cpl:and 31:ret z
 ld hl,bgr_fade,(bgr_poi+1),hl
 ret
bgr_fade:
bf:ld hl,$5000
 push hl
 xor a
 push hl
 ld (hl),a:inc hl
 ld (hl),a:inc hl
 ld (hl),a:inc hl
 ld (hl),a
 pop hl
 inc h,h
 ld (hl),a:inc hl
 ld (hl),a:inc hl
 ld (hl),a:inc hl
 ld (hl),a
 pop hl
 inc hl,hl,hl,hl
 ld (bf+1),hl
 ld de,$5204:or a:sbc hl,de:ret nz
 pop af
 ret

bgr_set_pal:
 ld bc, FMAddr
 ld a, %00010000
 out (c), a

;load CRAM
 ld de,0
 ld bc,512
 ldir

 ld bc, FMAddr
 xor a
 out (c), a
 ret
;-------------------------------------------------------------------------------------------------------------------------
end
 
 org $8000
begin2

part6:
stplace equ $4000
 ld hl,st,de,stplace,bc,256:ldir

 LD	BC,VConfig
;- LD	A,VID_320X200|VID_256C
 LD	A,VID_360X288|VID_256C
 OUT	(C),A


 ld ixl,200;y
 ld a,$20
drlp1:
 ei:halt
 call clear_page_dma
 inc a
 cp $27+2:jr nz,drlp1

 ld a,$20
 LD	BC,VPage
 OUT	(C),A

;------------mk palette

 ld bc, FMAddr
 ld a, 0x10
 out (c), a
 ld hl,0
 ld b,0
sd_pal:
 push hl
 ld a,b
 bit 5,a:jr z,sd_noinv
 cpl
sd_noinv:
 and 31
 ld l,a,h,0
 push hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 push hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 pop de:add hl,de
 pop de:add hl,de
 ex de,hl
 pop hl
 ld (hl),e:inc hl
 ld (hl),d:inc hl
 inc b:jp nz,sd_pal

;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a

lutpl equ $4100;;bank, MSB addres=2*$100
 ld hl,lutpl
  push hl
  ld de,hl
  inc de
  ld (hl),0
  ld bc,511
  ldir
  pop hl
  ld de,$C020;bank #
lulp1:
 ld (hl),e;bank
 inc h
; ld a,d:sub $C0
 ld (hl),d
 dec h

 inc d,d
 ;ld a,d:or a
 jr nz,nonextbank
 ld d,$c0
 inc e
nonextbank:
 inc l
; ld a,l
; cp 200
 jr nz,lulp1
;-----------------test plot
sdlp1:ei:halt

ab:ld bc,0;B=b,C=a
cd:ld de,0;D=c,E=d
  ld h,stplace/256
  xor a:ld (colm),a
  call drawdots
ab1:ld bc,$00FA;B=b,C=a
cd1:ld de,#0600;D=c,E=d
 ld a,$AF,(colm),a

 call drawdots

 inc iyh
;a0=a0+1
;c0=c0-1
 ld hl,(ab+1)
 inc l
 ld (ab+1),hl
 
 ld hl,(cd+1)
 dec h
 ld (cd+1),hl
;
;a01=a01+1
;c01=c01-1
 ld hl,(ab1+1)
 inc l
 ld (ab1+1),hl
 
 ld hl,(cd1+1)
 dec h
 ld (cd1+1),hl

sd_poi:call sd_wait
 jp sdlp1
sd_wait:
 ld a,(notecnt)
 cp $2B
 ret nz
; ret
; xor a:in a,($FE):cpl:and 31:ret z
 ld hl,sd_erase,(sd_poi+1),hl
 ret
sd_erase:
se_v1:ld hl,lutpl
 push hl
 ld a,(hl)
 ld (hl),$1F
 ld bc,Page3
 out (c),a
 inc h:ld h,(hl)
 ld l,128-32-16-2,b,0,e,b

sd_line:
 ld (hl),e
 inc hl
 djnz sd_line

 pop hl
 inc l
 ld (se_v1+1),hl
 ret nz
 pop af
 ret
 
drawdots:
  ld ixl,0;i
sdlp2:
;      x.b=S((a+64)&255)+s((b+64)&255);;+s(c)
;      y.b=s(c)+s(d)
;     Plot(x+240,y+240,65280)
;     a=a+1
;     b=b+3
;     c=c+1
;     d=d+2
 ld l,c
 ld a,(hl)
 ld l,b
 add a,(hl)
 add a,$60+40-8
 ld iyl,a;x
 ld l,e
 ld a,(hl)
 ld l,d
 add a,(hl)
 add a,$60+40-8

; ld iyh,a;y
 
; push iy
 exx
; pop de;D=Y.X
; ld d,iyh
 ld e,iyl
 ld h,lutpl/256
 ld l,a;Y and bank
 ld a,(hl)
; or a:jr z,nextp
 inc h
 LD	BC,Page3
 OUT (C),A
 ld h,(hl)
 
 ld l,$40
 ;ld l,e;suppose X

 ld d,0:add hl,de

 ld a,iyh
 inc iyh
; ld a,ixl;ld a,h:xor l
; and ixh
colm:nop
colr: ld (hl),a
nextp:
 exx
 inc c
 inc b,b
 inc e
 inc d,d,d
 inc ixl
 jp nz,sdlp2
 ret

st:incbin "sined.bin"
;-------------------------------------BARS+final-----------------------------------------------
part7:
 ld hl,$5000,de,$5001,bc,511,(hl),l:ldir
 ei:halt
 ;open FMAddr access from 0x8000
 ld bc, FMAddr
 ld a, %00010000;0x18
 out (c), a
 ld hl,$5000,de,0,bc,512:ldir
;load CRAM
 ld de,0
 ld hl,bars_pal_b
 ld bc,bars_pal_e-bars_pal_b
 ldir
;close FMAddr
 ld bc, FMAddr
 xor a
 out (c), a
 ld bc,TSConfig
 out (c), a
 ld bc,Border
 out (c),a
;PalSel = %00 //   0   0
;PalSel          EQU	#07AF
 ld bc,PalSel
 xor a
 out (c),a

 ld a,56
; call clear_page_dma
 ld bc,T0GPage; = 16 //    0   $10
 out (c),a
 ld bc,T1GPage
 out (c),a

; ld hl,fnt_pack,de,$5000:call dzx7_standard
; ld hl,fnt_pack,de,$4000:call dzx7_standard
; call convert_font
 
 ld hl,bartile_p,de,$4000:call dzx7_standard


; MAP tile
; ld a,$11
; call clear_page_dma
 ei:halt
 ld a,$12
 call clear_page_dma
 ld bc,TMPage
 out (c),a

 ei:halt
 LD	BC,VConfig
 LD	A,VID_NOGFX | VID_360X288
 OUT	(C),A

 ld bc,TSConfig

 ld a,TSU_T0EN | TSU_T1EN | TSU_T0ZEN | TSU_T1ZEN |TSU_SEN
 out (c),a
;---prepare sprite-----------------
 ld de,64;0+192
 ld bc,8+8
 call recalc_sprite;de=192,bc=16

mm:ei:halt
bars_poi2:call draw_bars
 ld a,56
 ld bc,Page3
 out (c),a

 ld de,$C004;where to put
; ld de,$C000+16*4;where to put

mm1:ld a,0
 inc a
 and 31
 ld (mm1+1),a
 
 ld h,1,l,a
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
 add hl,hl
; ld hl,$4000;tileadres

 ld ixl,16+4*4;*4/2
bars_lp:
 ld a,(hl):inc l
 dup 7
 ld (de),a:inc d
edup
 ld (de),a
 inc e

 ld a,(hl):inc l
 dup 7
 ld (de),a:dec d
edup
 ld (de),a
 inc e

 dec ixl
 jp nz,bars_lp

bars_poi:call bars_void;scroll

 jp mm

bars_text:
;IX=text
;HL=adr
;A=amount
t4x4_lp1:
 exa;push af
 ld d,64
 ld a,(ix):inc ix
 cp 32:jr nz,letter
 ld a,35:ld d,0:jr let2
letter:
 sub 65
 ld e,a
 add a,a
 add a,e
 add a,d;64
let2:
 ld (hl),a:inc h
 add a,d;64
 ld (hl),a:inc h
 add a,d;64
 ld (hl),a
 inc a
 inc l,l
 ld (hl),a:dec h
 sub d;64
 ld (hl),a:dec h
 sub d;64
 ld (hl),a
 inc l,l
 inc a
 ld (hl),a:inc h
 add a,d;64
 ld (hl),a:inc h
 add a,d;64
 ld (hl),a
 dec h,h
 inc l,l
 exa;pop af
 dec a
 jp nz,t4x4_lp1

 ret
;-----------------part routines----------------
bars_wait:
 ld a,(notecnt)
 cp $35
 ret nz
 ld a,$12
 ld bc,Page3
 out (c),a
 ld a,7
 ld hl,$d080+20+4
 ld ix,theend
 call bars_text;text4x4
 ld hl,bars_void,(bars_poi2+1),hl
 ret
theend: db "THE END",0


draw_bars:
 ld a,$12
 ld bc,Page3
 out (c),a

db_v1: ld hl,$C000
 push hl
; ld c,37
;drwti_lp1:
; push hl
 ld b,16
 ld e,16;+16-1
drwti_lp2:
 ld (hl),e:inc l
 ld (hl),$40:inc l
 dec e
 djnz drwti_lp2

 ld de,8*3+2
 add hl,de
 
 ld b,16+1
 ld e,1;+16-1
drwti_lp3:
 ld (hl),e:inc l
 ld (hl),$40*0:inc l
 inc e
 djnz drwti_lp3

 pop hl
 inc h
 ld (db_v1+1),hl
db_v2:ld a,37
 dec a
 ld (db_v2+1),a
 ret nz
 ld hl,bars_void,(bars_poi2+1),hl
 ld hl,scroll,(bars_poi+1),hl
bars_void:
 ret


scroll:
scv1:ld a,0
 inc a
 inc a
 cp 24
 jp nz,no_new_text

 ld a,$12
 ld bc,Page3
 out (c),a
scv2: ld ix,scrollt
 ld a,(ix+16)
 cp 0:jr nz,bars_no_inc
; ld a,$C9,(scv1),a
 ld hl,bars_void,(bars_poi+1),hl
 ld hl,bars_wait,(bars_poi2+1),hl
bars_no_inc:
 inc ix
 ld (scv2+2),ix

 ld hl,$D080
 ld a,16
 call bars_text

  xor a
no_new_text:
 ld (scv1+1),a
 ld bc,T1XOffsL
 out (c),a
 xor a:inc b
 out (c),a
 ld de,$C000+16*4;where to put

 ld a,$10
 ld bc,Page3
 out (c),a
 ret
;----------------------------------------------------
recalc_sprite:
; ret
;DE=Y
;BC=X
 ld ix,sprite_b
 ld a,6
rec_s_lp:
 exa
 ld a,e
 ld (ix+0),a
 ld a,d
 and 1
 or %00101110
 ld (ix+1),a

 ld a,c
 ld (ix+2),a
 ld a,b
 and 1
 or %00001110
 ld (ix+3),a
 ld (ix+5),%00010000
 
 ld a,c:add a,64:ld c,a
 ld a,b:adc a,0:ld b,a
 inc ix,ix,ix,ix,ix,ix
 exa
 dec a
 jp nz,rec_s_lp
 
 ld a,$10
 ld bc,FMAddr
 out (c),a
 ld hl,sprite_descr_b
 ld de,512
 ld bc,sprite_descr_e-sprite_descr_b;512
 ldir
 xor a
 ld bc,FMAddr
 out (c),a

 ret
;----------------------------------------------------
bars_pal_b:
 dw 0;0
 dw 1056*24;1
 dw 33*17;2
 dw 33*16;3
 dw 33*12;4
 dw 33*10;5
 dw 33*8;6
 dw 33*6;7
 dw 33*4;8
 dw 33*2;9
 dw $7FFF;10
 dw $7FFF;11
 dw $7FFF;12
 dw $7FFF;13
 dw $7FFF;14
 dw $7FFF;15

spr_pal:
 dw $0,$231,$14A,$37C,$318,$2F7,$A5,$2D6,$1EF,$2B5,$1CE,$3BE,$294,$1AD,$273,$33A

; dup 16/4
; dw 32*31
;edup
bars_pal_e:

;---------------------routines----------------------------
bartile_p:incbin "bartile.bin.zx7"
;zx7:include "zx7.a80"
;fnt_pack:incbin "AVANTFNT.zx7"

scrollt:
 db "                ALAS BOUR JOURNEB TO CAROUSEL"
 db " CAME TO AN END THANKS FOR QATCHING                "
 db 0

; db "            Alas your journey to Carousel"
; db " came to an end Thanks for watching             789"
; db 0

sprite_descr_b:
 db $FF
 db %01000000
 db $FF
 db %01100011
 db 0
 db 0

sprite_b:
;----------------------
 db 0;0 --Y
 db %00101110;%01100010;1 --YF,leap,b0=position*256+pl_Y - disp for sprites,YF	LEAP	ACT	reserved	YS[2:0]			Y[8]
;   %0LA0SSSy;ss=1100(6),2^6=64 sprite size
 db 0;2 --X
 db %00001110;3 --XF 111111, b0 - same remark
 db 0
 db %00010000;5
;   %xxxx0000-xxxx-palnum,SPAL[7:4]				TNUM[11:8]

 db 0;Y
 db %00101110;YF
 db 64;/2;X
 db %00001110;XF
 db 8;TNUM
 db %00010000;palette num
;
 db 0;Y
 db %00101110;YF
 db 128;X
 db %00001110;XF
 db 16;TNUM
 db %00010000;palette num

 db 0;Y
 db %00101110;YF
 db 128+64;X
 db %00001110;XF
 db 24;TNUM
 db %00010000;palette num
;ok

 db 0;Y
 db %00101110;YF
 db 0;X
 db %00001110+1;XF
 db 32;TNUM
 db %00010000;palette num
;
 db 0;Y
 db %00101110;YF
 db 64;X
 db %00001110+1;XF
 db 40;TNUM
 db %00010000;palette num
;

sprite_descr_e:


end2
;-----------------------------------------------
 page 6
 org $C000
page6b:
plyer:include "PTxPlay.a80"
song:incbin "song_.PT3"


pla_sin:incbin "plasmsin.bin"
plasm_fnt:incbin "plsm.fnt.zx7"

sintw:incbin "sintwist.bin"
twist0p:incbin "twist0.bin.zx7"
twist1p:incbin "twist1.bin.zx7"
gfnt_pack:incbin "gfont.bin.zx7"

rastasin:incbin"sinrasta.bin"

palb: incbin "rgbpal.bin"
page6e:
;	display fade_tw
	display end

	display /d,end-begin
	savebin "car.bin",begin,end-begin
	savebin "car2.bin",begin2,end2-begin2
	
	page 6
	savebin "song.bin",page6b,page6e-page6b

